#ifndef XSTDBOOL_H_DEFINED_
#define XSTDBOOL_H_DEFINED_

#ifdef HAVE_STDBOOL_H

#if defined(__LCLINT__)
typedef enum { false, true } bool;	/* because bool is not known to lclint or splint */
/* NB: lclint and splint will need:  -booltype bool -booltrue true -boolfalse false */
#endif

#include <stdbool.h>

#if !defined(__cplusplus) && !defined(HAVE__BOOL)
typedef int _Bool;		/* some systems have <stdbool.h> but no _Bool, sigh... */
#endif

#else

/* NB: 1999 ISO Standard C requires that bool, true, and false be macros! */

#ifdef __cplusplus
#define _Bool bool
#define true true
#define false false
#else
/* Some C compilers now recognize _Bool as a language keyword, and
   reject attempts to create a typedef for it, but still lack
   <stdbool.h>.  We therefore remap that keyword to a private type. */
#define _Bool my_boolean_t
typedef enum { __false = 0, __true = 1 } _Bool;
#define true __true
#define false __false
#define bool _Bool
#endif  /* __cplusplus */

#define __bool_true_false_are_defined 1

#endif

#endif /* XSTDBOOL_H_DEFINED_ */
